﻿Ext.util.CSS.createStyleSheet('.kpi-tiles{margin-bottom: 20px;}');
Ext.util.CSS.createStyleSheet('.kpi-meta {width: 100%;background-color: #fff;-moz-box-shadow: 0px 1px 1px 0px rgba(0, 0, 0, 0.25);box-shadow: 0px 1px 1px 0px rgba(0, 0, 0, 0.25)}');
Ext.util.CSS.createStyleSheet('.kpi-meta span {border-right: 1px solid #ececec;display: inline-block;text-align: center;padding: 20px 0;height: 100%;width: 25%;white-space: nowrap;overflow: hide;text-transform: uppercase;color: #a0a7b8;font-weight: 800;font-size: 15px}');
Ext.util.CSS.createStyleSheet('.kpi-meta span div {font-size: 28px;color: #878ea2;font-weight: 400;padding-bottom: 5px;padding-top: 5px}');
Ext.util.CSS.createStyleSheet('.kpi-meta span:last-child {border-right: none }');
Ext.define('App.Control.Kivii.Finances.Statistic.Chart', {
    extend: 'Ext.Panel',
    xtype: 'App.Control.Kivii.Finances.Statistic.Chart',
    // requires: ['Package.charts'],
    autoScroll: true,
    // dockedItems: [{
    //     xtype: 'toolbar',
    //     dock: 'top',
    //     overflowHandler: 'scroller',
    //     items: [{
    //         text: '新增数据',
    //         iconCls: 'x-fa fa-money',
    //         type: 'Payment',
    //         handler: '_onCreateApply'
    //     }]
    // }],
    viewModel: {
        data: {
            _statistic: []
            // [{
            //     description: '待认领流水',
            //     Amount: 10000,
            //     Quantity: 67
            // }, {
            //     description: '待开票流水',
            //     Amount: 500000,
            //     Quantity: 57
            // }, {
            //     description: '待使用流水',
            //     Amount: 40000,
            //     Quantity: 27
            // }, {
            //     description: '待结算报告',
            //     Amount: 40000,
            //     Quantity: 27
            // },{
            //     description: '已结算未收费',
            //     Amount: 965000,
            //     Quantity: 77
            // }]
        }
    },
    items: [{
        xtype: 'component',
        reference: 'statistic',
        autoRender: true, //默认是false,当data绑定的数据发生变化时会自动重新render
        id: 'fdfd',
        cls: 'kpi-tiles',
        tpl: [
            '<div class="kpi-meta">',
            '<tpl for=".">',
            '<span>',
            '<div>{TotalAmount}元</div> {Description}<div style="font-size: 20px;">{TotalQuantity}条</div>',
            '</span>',
            '</tpl>',
            '</div>'
        ],
        bind: {
            data: '{_statistic}'
        }
    }],
    listeners: {
        beforerender: '_viewReady'
    },
    controller: {
        _viewReady: function(_this, _eOpts) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            
            Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.Payment/UnSplitAnalysis.json',
                success: function(_response) {
                    var _rtns = Ext.decode(_response.responseText);
                    let _data = [];
            		Ext.apply(_data, _vm.data._statistic); //!!!!!!!!!!!
            		_data.splice(0,0,_rtns);
                    // _data.push(_rtns);
                    // _vm.data._statistic.push(_item);
                    _vm.set('_statistic', _data);
                },
                failure: function(_response) {}
            });
            Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.Payment/UnInvoiceAnalysis.json',
                params:{
                	OwnerKvid:KiviiContext.CurrentMember.DepartmentKvid
                },
                success: function(_response) {
                    var _rtns = Ext.decode(_response.responseText);
                    let _data = [];
            		Ext.apply(_data, _vm.data._statistic); //!!!!!!!!!!!
                    _data.splice(1,0,_rtns);
                    // _data.push(_rtns);
                    // _vm.data._statistic.push(_item);
                    _vm.set('_statistic', _data);
                },
                failure: function(_response) {}
            });
            Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.Payment/UnUsedAnalysis.json',
                params:{
                	OwnerKvid:KiviiContext.CurrentMember.DepartmentKvid
                },
                success: function(_response) {
                    var _rtns = Ext.decode(_response.responseText);
                    let _data = [];
            		Ext.apply(_data, _vm.data._statistic); //!!!!!!!!!!!
                    _data.splice(2,0,_rtns);
                    // _data.push(_rtns);
                    // _vm.data._statistic.push(_item);
                    _vm.set('_statistic', _data);
                },
                failure: function(_response) {}
            });
            Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.Settlement/UnPayedAnalysis.json',
                params:{
                	OwnerKvid:KiviiContext.CurrentMember.DepartmentKvid
                },
                success: function(_response) {
                    var _rtns = Ext.decode(_response.responseText);
                    let _data = [];
            		Ext.apply(_data, _vm.data._statistic); //!!!!!!!!!!!
                    _data.splice(3,0,_rtns);
                    // _data.push(_rtns);
                    // _vm.data._statistic.push(_item);
                    _vm.set('_statistic', _data);
                },
                failure: function(_response) {}
            });
        },
        _onCreateApply: function(_ctrl) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            let _refs = _controller.getReferences();
            let _data = [];
            Ext.apply(_data, _vm.data._statistic); //!!!!!!!!!!!
            let _item = {};
            _item.description = "dynamicData";
            _item.Amount = 4355555;
            _item.Quantity = 345;
            _data.push(_item);
            // _vm.data._statistic.push(_item);
            _vm.set('_statistic', _data);
            // _view.render('component');
        }
    }
});